const chalk = require('chalk');
const log = console.log;
const inquirer = require('inquirer');
var fs = require('fs');
var replace = require('replace');
var glob = require('glob');
var generateModel = require('./generateModel');
var createFirebaseConfig = require('./createFirebaseConfig');

const ylog = function(msg){
    log(chalk.yellow(msg));
};

const rlog = function(msg){
    log(chalk.red(msg));
};

const blog = function(msg){
  log(chalk.blue(msg));
};
path = require('path');


module.exports.cli = function(){
var rootDirectory = path.dirname(fs.realpathSync(__filename));



rlog("Please wait...");
ylog("Initializing App");






/* var questions = [{
    type: 'input',
    name: 'apiKey',
    message: "Please enter API KEY For Firebase",
  },
  {
    type: 'input',
    name: 'databaseURL',
    message: "Please enter Database URL For Firebase",
  },
  {
    type: 'input',
    name: 'authDomain',
    message: "Please enter Auth Domain For Firebase",
  }] */
  



  var questions = [{
    type: 'input',
    name: 'model',
    message: "Please enter Model Name For Crud Operations",
  },{
    type: 'input',
    name: 'firebaseModel',
    message: "Please enter Firebase Model Name",
  },{
    type: 'input',
    name: 'path',
    message: "Please enter Router Path",
  },{
    type: 'input',
    name: 'menuName',
    message: "Please enter Menu Name",
  }]


  var firebaseConfig = [{
    type: 'input',
    name: 'apiKey',
    message: "Please enter Firebase API KEY",
  },{
    type: 'input',
    name: 'authDomain',
    message: "Please enter Firebase Auth Domain",
  },{
    type: 'input',
    name: 'databaseURL',
    message: "Please enter Firebase DatabaseUrl",
  },{
    type: 'input',
    name: 'projectId',
    message: "Please enter Firebase Project Id",
  },{
    type: 'input',
    name: 'storageBucket',
    message: "Please enter Firebase Storage Bucket",
  },
  {
    type: 'input',
    name: 'messagingSenderId',
    message: "Please enter Firebase Messaging Sender Id",
  }]





  var output = [];
  var modelProps = [];
var newModelQuestion = [
  {
    type: 'confirm',
    name: 'askAgain',
    message: 'Want To Add a new Model now ?',
    default: false
  }
]
  var modelPropsQuestions = [
    {
      type: 'input',
      name: 'modelName',
      message: "What's your Property Name"
    },
    {
      type: 'input',
      name: 'modelTitle',
      message: "What's your Property Title"
    },
    {
      type: 'list',
      name: 'modelType',
      message:  "What's your Property Type",
      choices: [
        'Text',
        'Array',
        'Object',
        'Image',
        'Image Array'
      ]
    },
    {
      type: 'confirm',
      name: 'askAgain',
      message: 'Want to enter next property',
      default: true
    }
  ];
  
  function ask() {
    inquirer.prompt(modelPropsQuestions).then(answers => {
      output.push({
        name:answers.modelName,
        title:answers.modelTitle,
        type:answers.modelType
      });
      if (answers.askAgain) {
        ask();
      } else {

        var generateModelByCli = new generateModel();
        generateModelByCli.genereteTemplate(modelProps,output);

       

        

      }
    });
  }


  function wantToAddNewModel() {
    inquirer.prompt(newModelQuestion).then(answers => {
    
      if (answers.askAgain) {
        inquirer.prompt(questions).then(answers => {
    
          modelProps = answers;
          ask();
        });
      
      } else {

        blog("Admin Panel Setup Compelete");
       

        

      }
    });
  }
  
  inquirer.prompt(firebaseConfig).then(answers => {
          

    var createFirebaseInit = new createFirebaseConfig();
    createFirebaseInit.genereteTemplate(answers);
    blog("");
    ylog("Firebase config file Has been Created Succesfully");
    blog("");
  
    wantToAddNewModel();

   
    


  });


}


